--@Author: Sven777b
--@Web: www.ls-landtechnik.com

schweinemastPlaceable = {};
schweinemastPlaceable_mt = Class(schweinemastPlaceable, Placeable);
InitObjectClass(schweinemastPlaceable, "schweinemastPlaceable");

function schweinemastPlaceable:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, schweinemastPlaceable_mt);
    registerObjectClassName(self, "schweinemastPlaceable");
    return self;
end;

function schweinemastPlaceable:delete()
    unregisterObjectClassName(self);
    schweinemastPlaceable:superClass().delete(self);
end;

function schweinemastPlaceable:deleteFinal()
    schweinemastPlaceable:superClass().deleteFinal(self);
end;

function schweinemastPlaceable:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
    if not schweinemastPlaceable:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;
    local xmlFile = loadXMLFile("TempXML", xmlFilename);
    if not moveMode then
		self.searchOnCreateObjects = schweinemastPlaceable.searchOnCreateObjects;
		g_currentMission.isLoadingMap = true;
			self:searchOnCreateObjects(self.nodeId);
		g_currentMission.isLoadingMap = false;
	end;
    delete(xmlFile);
    return true;
end;

function schweinemastPlaceable:searchOnCreateObjects(node)
    for i=1,getNumOfChildren(node) do
        local c = getChildAt(node, i-1);
        if getUserAttribute(c,"onCreate")~= nil  then
			local stringname = string.sub(getUserAttribute(c,"onCreate"),13);
			if g_onCreateUtil.onCreateFunctions[stringname] ~= nil then
				g_onCreateUtil.onCreateFunctions[stringname](c);			
			end;
			if getNumOfChildren(c) >0 then
				self:searchOnCreateObjects(c);
			end;
        else
            self:searchOnCreateObjects(c);
        end;
    end;
end;

registerPlaceableType("schweinemastPlaceable", schweinemastPlaceable);